'use strict';

let ExtractSVGPlugin = require('boi-svg-sprite-loader/lib/extract-svg-plugin');
let WebpackHtmlInjectPlugin = require('webpack-html-inject-plugin');

let extractSvgPlugin = ExtractSVGPlugin()

let ClassLoader = boi.PluginClass.loader;

const DEFAULT_CONFIG = {
    // 编译输出的文件路径
    name: 'svg/svg-sprite.[contenthash:8].svg',
    // 是否将编译输出的svg结构注入html中
    inject: false,
    // 需注入的目标html文件
    injectTargets: ['index.html']
};

let options = Object.assign({},DEFAULT_CONFIG);

let webpack_config = {
    module: {
        preloader: null,
        postloader: null,
        loaders: [{
            test: /\.svg$/,
            loader: ExtractSVGPlugin.extract('boi-svg-sprite?extract=true')
        }]
    },
    plugins: []
};

module.exports = function(opts){
    if(opts){
        options = Object.assign({},options.opts);
    }
    let _plugins = [];
    _plugins.push(new ExtractSVGPlugin(options.name));

    if(options.inject){
        _plugins.push(new WebpackHtmlInjectPlugin({
            mode: 'inject',
            contentFile: options.name,
            targets: options.injectTargets
        }));
    }else{
        _plugins.push(new WebpackHtmlInjectPlugin({
            mode: 'repalceUrl',
            srcUrl: options.name,
            targets: options.injectTargets
        }));
    }
    webpack_config.plugins = webpack_config.plugins.concat(_plugins);

    new ClassLoader('extend',webpack_config)
}
